﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Dim EditText As EditText
	Private LabelMove As Label
	Private MainPanel As Panel
	
	Private LastClick As Long = 0
	Private CountClick As Int = 0
	Private TimeLapse As Long = 2500
	Private Start, Stop As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(E As EditText,Color As Int, TextColor As Int)
	MainPanel = E.Parent
	EditText=E
	
	LabelMove.Initialize("LabelMove_Touch")
	LabelMove.Color=Bit.Or(Bit.And(Color,0xFFFFFF),0x55000000)
	LabelMove.TextColor=TextColor
	MainPanel.AddView(LabelMove,E.Left,E.Top,E.Width,E.Height)
	E.BringToFront
	
	Dim R As Reflector
'	R.Target=LabelMove
'	R.SetOnTouchListener("LabelMove_Touch")
	
	r.target=EditText
	R.SetOnTouchListener("LabelMove_Touch")
	R.SetOnClickListener("EditText_Click")
End Sub

Private Sub LabelMove_Touch(viewtag As Object, action As Int, X As Float, Y As Float, motionevent As Object) As Boolean
	Dim TimePassed As Long = DateTime.Now-LastClick
	Select action
		Case 0 ' Down
			Dim i As IME
			i.Initialize("")
			i.HideKeyboard

			LabelMove.Text=EditText.Text
			If DateTime.Now-LastClick<TimeLapse Then 
				CountClick=CountClick+1
				' Click and Select
				If  CountClick=1 Then 
					SelectLastChar
					LastClick=DateTime.Now
				else if CountClick=2 Then
					SelectWord(EditText.SelectionStart)
					LastClick=DateTime.Now
				else If CountClick>2 Then 
					SelectAll
					LastClick=0
					CountClick=0
				End If
				Dim i As IME
				i.Initialize("")
				i.ShowKeyboard(EditText)
				Selected
			Else
				CountClick=0
				LastClick=DateTime.Now
			End If
			Return False
		Case 1 ' UP
			If TimePassed<TimeLapse Then 
				LabelMove.Left=EditText.Left
				LabelMove.Top=EditText.Top
				EditText.BringToFront
				
'				Dim i As IME
'				i.Initialize("")
'				i.ShowKeyboard(EditText)
'				Selected
				Return False
			Else
				For Each V As View In MainPanel.GetAllViewsRecursive
					If GetType(V)="android.widget.EditText" Then
						If InPlace(LabelMove,V) Then
							Dim E As EditText = V
							E.Text=LabelMove.Text
						End If
					End If
				Next
			
				EditText.Width=EditText.Width
				LabelMove.SetLayoutAnimated(100,EditText.Left,EditText.Top,EditText.Width,EditText.Height)
				EditText.BringToFront
			
				LabelMove.Text=""
			End If
		Case 2 ' move
			If TimePassed>=TimeLapse Then
				LabelMove.BringToFront
				LabelMove.Left=x
				LabelMove.top=y
			End If
	End Select
		
	Return True
End Sub

Private Sub EditText_Click(viewtag As Object)
	Dim i As IME
	
	i.Initialize("")
	i.ShowKeyboard(EditText)
End Sub

Private Sub InPlace(v1 As View,v2 As View) As Boolean
	Dim l1 As Int = v1.Left
	Dim t1 As Int = v1.Top
	Dim w1 As Int = v1.Width
	Dim h1 As Int = v1.Height
	
	Dim l2 As Int = v2.Left
	Dim t2 As Int = v2.Top
	Dim w2 As Int = v2.Width
	Dim h2 As Int = v2.Height
	
	Dim l3 As Int = l1 + w1
	Dim t3 As Int = t1 + h1
	Dim l4 As Int = l2 + w2
	Dim t4 As Int = t2 + h2
	
	If (l1>=l2 And l1<=l4)Or(l3>=l2 And l3<=l4) Then
		If (t1>=t2 And t1<=t4)Or(t3>=t2 And t3<=t4) Then
			Return True
		End If
	End If
	Return False
End Sub

Private Sub SelectWord(Pos As Int)
	Dim Start As Int = Min(EditText.Text.Length-1,Pos)
	Dim Stop As Int = Min(EditText.Text.Length-1,Pos)
	Dim S As String = EditText.Text
	
	Do While Start>0 And S.CharAt(Start)<>" "
		Start=Start-1
	Loop
	If S.CharAt(Start)=" " Then Start=Start+1
	
	Do While Stop<S.Length-1 And S.CharAt(Stop)<>" "
		Stop=Stop+1
	Loop
	Stop=Min(Stop+1,EditText.Text.Length)
	Selected
End Sub

Private Sub SelectAll
	Start=0
	Stop=EditText.Text.Length
	Selected
End Sub

Private Sub SelectLastChar
	Start=EditText.Text.Length
	Stop=Start
	Selected
End Sub

Private Sub Selected
	Sleep(50)
	Dim jo = EditText As JavaObject
	jo.RunMethod("setSelection", Array As Object(Start, Stop))
End Sub